#ifndef READRGB_H
#define READRGB_H

#include <GL/gl.h>

/*
 * Load an SGI .rgb file and return a pointer to the image data.
 * Input:  imageFile - name of .rgb to read
 * Output:  width - width of image
 *          height - height of image
 *          format - format of image (GL_RGB or GL_RGBA)
 * Return:  pointer to image data or NULL if error
 */
GLubyte *LoadRGBImage( const char *imageFile, GLint *width, GLint *height,
                       GLenum *format );

/*
 * Write a .tiff file.
 * Input:  imageFile - name of .tiff to write
 * Output:  width - width of image
 *          height - height of image
 *          format - format of image (GL_RGB or GL_RGBA)
 *          image - the data in the given format
 * Return:  success
 */
int WriteRGBImage( const char *imageFile, GLint width, GLint height,
		   GLenum format, GLubyte *image);

#endif /* READRGB_H */
