/*
** renderer.h - header file for builtin rendering
*/

#ifndef RENDERER_H
#define RENDERER_H

#include "lightfield.h"

/* renderer using the volpack library */
bool_t lfVPAlloc(LFRenderer *renderer);
void lfVPDone(LFRenderer *renderer);
bool_t lfVPRender(LFRenderer *renderer,
		   Matrix4 mat_model, Matrix4 mat_proj, int width, int height,
		   int format, void *pixels);
void lfVPRenderParams(LFRenderer *renderer);

/* renderer using the VolVis library */
bool_t lfVVAlloc(LFRenderer *renderer);
void lfVVDone(LFRenderer *renderer);
bool_t lfVVRender(LFRenderer *renderer,
		   Matrix4 mat_model, Matrix4 mat_proj, int width, int height,
		   int format, void *pixels);
void lfVVRenderParams(LFRenderer *renderer);

/* renderer using the RIB protocol */
bool_t lfRIBAlloc(LFRenderer *renderer);
void lfRIBDone(LFRenderer *renderer);
bool_t lfRIBRender(LFRenderer *renderer,
		   Matrix4 mat_model, Matrix4 mat_proj, int width, int height,
		   int format, void *pixels);
void lfRIBRenderParams(LFRenderer *renderer);

#endif /* RENDERER_H */
