/*
** code shared by VolVis and volpack renderer
*/

#include "lightfield.h"
#include <limits.h>



#define DENSITY_MAX	UCHAR_MAX

/*
** histogram of current volume
*/
extern int volHistogram[DENSITY_MAX + 1];
extern int volHisMax;
void volCalcHistogram(unsigned char *density, int size,
		      int histo[UCHAR_MAX],
		      int *max);

extern float density_ramp[DENSITY_MAX + 1];
extern int ramp_x[4];
extern float ramp_y[4];

void lfVolSetRampVals(int position, int steepness);
void lfVolSetRamp(LFRenderer *renderer);
void lfVolRenderParams(LFRenderer *renderer);
void lfVolSetPosition(vpContext *vpc, int width, int height, bool_t volvis);

typedef struct
{
   int dummy;
} LFShading;

bool_t lfVPRenderVPC(vpContext *vpc,
		     Matrix4 mat_model, Matrix4 mat_proj, int width, int height,
		     int format, void *pixels, LFShading *shading);
bool_t lfVPSetTransfer(vpContext *vpc, int position, int steepness,
		       int *old_pos, int *old_steep);
bool_t lfVPInitVPC(vpContext *vpc, void *volume, int x, int y, int z, int quality);

/* if set, volume rendering will set the average opacity */
extern float *volOpacity;
float lfVolCalcOpacity(int *histo, float *ramp, int entries);

